=== changelog ===
nomacs (0.4.0) unstable; urgency=low

  * Bug #135: translation files for linux
  * Bug #144: can't load nef file
  * Bug #148: image is moved to left lower corner in viewport
  * Bug #150: contrast tool crash
  * Bug #152: disable slideshow when end of directory is reached 
  *           and wrap images is off
  * Bug #131: hidden crop rectangle
  * Bug #136: end of dir
  * Bug #149: F5 does not update
  * Bug #151: subclassing DkWidget
  * Bug #154: crop tool - background is not filled correctly
  * Feature #137: preferences for caching
  * Feature #143: reopen widgets
  * Feature #147: How to save my setup?
  * Feature #112: Translate interface
  * Feature #127: snap cropping
  * Feature #145: Anzeige von weiteren RAW Formaten
   
 -- Stefan Fiel <stefan@nomacs.org>  Mon, 25 Jul 2012 11:00:15 +0200

nomacs (0.3.3) unstable; urgency=low

  * internal release

 -- Stefan Fiel <stefan@nomacs.org>  Thu, 21 May 2012 08:30:22 +0200

nomacs (0.3.2) unstable; urgency=low

  * Bug #128: restore old "open" dialog
  * Bug #129: Frameless for multiple monitors
  * Bug #130: rescaling transparent images
  * Bug #132: crop tool crops wrong area
  * Bug #133: resize
  * Feature: percent in resize dialogue
  * Feature: chinese translation
  * Feature: fast file indexing (for windows only)
 
 -- Stefan Fiel <stefan@nomacs.org>  Thu, 15 May 2012 15:10:22 +0200

nomacs (0.3.1) unstable; urgency=low

  * internal release

 -- Stefan Fiel <stefan@nomacs.org>  Thu, 10 May 2012 16:30:22 +0200
 

nomacs (0.3.0) unstable; urgency=low

  * Bug #55: performance loss when loading from network
  * Bug #97: toWCharArray
  * Bug #98: Absturz - Open With Dialog
  * Bug #99: nomacs.desktop: update mime types not to include directory
  * Bug #100: zoom 100%
  * Bug #110: date string bug
  * Bug #114: saving files
  * Bug #116: event echo
  * Bug #118: image loader
  * Bug #124: pseudo color function
  * Bug #125: slow start-up if network drive is mounted
  * Bug #126: thumbloader focus
  * Bug #128: restore old "open" dialog
  * Feature #13: Frameless
  * Feature #34: Bildwechsel mit Scrollrad
  * Feature #43: crop images
  * Feature #74: open with
  * Feature #93: add button to adjust windows size to image size
  * Feature #113: symbolic links
  * Feature: crop tool
  * Feature: image resize
  * Feature: pseudo color toolbar
  * Feature: new icons
  * Feature: translations

 -- Stefan Fiel <stefan@nomacs.org>  Mon, 02 Mar 2012 17:30:22 +0200

nomacs (0.2.3) unstable; urgency=low

   * Bug #64: network - close connection
   * Bug #69: rating label
   * Bug #71: Network Server - not discoverable using vms
   * Bug #94: painter file info panel
   * Bug #95: save jpeg dialog ignores compression value
   * Feature #66: slideshow - player
   * Feature #67: display information (filenames)
   * Feature #68: silent loading
   * Feature #79: add showMenu, showToolbar and showStatusbar to Preferences
   * Feature #96: Format metadata

 -- Stefan Fiel <stefan@nomacs.org>  Mon, 19 Dec 2011 08:22:22 +0200

nomacs (0.2.0) unstable; urgency=low

  * from alpha to beta

 -- Stefan Fiel <stefan@nomacs.org>  Mon, 25 Oct 2011 15:22:22 +0200

nomacs (0.1.2) unstable; urgency=low

  * Initial release 

 -- Stefan Fiel <stefan@nomacs.org>  Mon, 15 Aug 2011 08:49:22 +0200
