=== control ===
Source: nomacs
Section: graphics
Priority: optional
Maintainer: Stefan Fiel <stefan@nomacs.org>
XSBC-Original-Maintainer: Stefan Fiel <stefan@nomacs.org>
Build-Depends: debhelper (>= 7.0.50~), cdbs (>= 0.4.90~), qt4-qmake, libqt4-dev, libexiv2-dev (>= 0.21.1~), libraw-dev (>= 0.13.1~), libcv-dev, libhighgui-dev, libcvaux-dev, cmake
Standards-Version: 3.9.3
Homepage: http://www.nomacs.org

Package: nomacs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: image viewer with capability of syncing multiple instances
 nomacs is a free image viewer for windows and linux systems, which is
 licensed under the GNU General Public License v3. nomacs is small, fast and 
 able to handle the most common image formats. Additionally it is possible to
 synchronize multiple viewers. A synchronization of viewers running on 
 the same computer or via LAN is possible. It allows one to compare images 
 and spot the differences (e.g. schemes of architects to show the 
 progress).
